Releases
--------

* RELEASE_3_4_2 2017/04/24
Features:
    v3 Devices:
    ************
    - small fix for UDP buffer size handling

	
* RELEASE_3_4_1 2017/03/27
Features:
    v3 Devices:
    ************
    - initial release for NetCom Plus Mini
    - added UPNP notify support
    - added WPA-Enterprise support
    - added the intercharacter serial read timeout function
    - added subsequent upload of viaVPN certification files
    - added debug and trace file on USB stick support
	
	
* RELEASE_3_3_6 2016/10/27
Features:
    v3 Devices:
    ************
    - fixed the configuration over the serial port
    - fixed memory bug in webserver
    - added conversion routine for version 3.3.1
	
	
* RELEASE_3_3_5 2016/05/25
Features:
    v3 Devices:
    ************
    - changed default UDP push timeout value
    - added new firmware update layer


Releases
--------
* RELEASE_3_3_4 2016/03/25
Features:
    v3 Devices:
    ************
    - added modem support
    - changed some web-frontend behaviors


* RELEASE_3_3_2 2016/01/18
Features:
    v3 Devices:
    ************
    - added viaVPN support
    - added support for software configurable external USB-COM devices
    - added sntp interval function
    - fixed negative UTC time bug
    - fixed WLAN problem with disabled encryption
	

* RELEASE_3_2_2 2015/08/05
Features:
    v3 Devices:
    ************
    - changed build environment for better performance


* RELEASE_3_2_1 2015/06/11
Features:
    v3 Devices:
    ************
    - changed I2C speed to 1kHz in the bootloader to fix start-up problems in the cold


* RELEASE_3_2_0 2015/05/28
Features:
    v3 Devices:
    ************
    - added support for WL18xx WLAN chip
    - added support for common VSCOM external serial USB adapter


* RELEASE_3_1_1 2015/02/12
Features:
    v3 Devices:
    ************
    - fixed bug when no LAN cable was plugged in (with DHCP), then fallback to WLAN even when its not available


* RELEASE_3_1_0 2015/02/11
Features:
    v3 Devices:
    ************
    - added GPIO support over Modbus TCP


* RELEASE_3_0_0 2014/12/02
Features:
    v3 Devices:
    ************
    - initial support for v3 NetComs


* RELEASE_2_6_4 2012/04/25
Features:
    PRO/WLAN Devices:
    ************
    - configuration for advanced Ethernet settings added


* RELEASE_2_6_3 2011/11/09:
Bugfixes:
    All Devices:
    ************
    - TCP Keep Alive settings will be kept after firmware upgrade

    ARM7 Devices:
    *************
    - don't answer to ICMP TIMESTAMP requests (crash fix)


* RELEASE_2_6_2 2010/06/11:
Features:
    PRO/WLAN Devices:
    *************
    - command line parameters for OpenVPN are now configurable

Bugfixes:
    All Devices:
    ************
    - '%' is now also accepted for text fields in the web interface

    ARM7 Devices:
    *************
    - devices behave correctly if DHCP server provides SNTP server names
 and SNTP client on NetCom's side is disabled
    - Hostnames for Null Modem Tunnel Mode are saved correctly

    PRO/WLAN Devices:
    *************
    - OpenVPN port numbers for server and client can be configured independently


* RELEASE_2_6_1 2009/04/07:
Bugfixes:
    PRO/WLAN Devices:
    *************
    - Setting some serial parameters was broken


* RELEASE_2_6_0 2008/11/20:
Features:
    PRO/WLAN Devices:
    *************
    - Flow control now uses even faster automatic on-chip handshake of
16C950 UART
    - Added WPA2 support (RaLink RT2561T WLAN chipset only)

Bugfixes:
    PRO/WLAN Devices:
    *************
    - Configuration of NetCom via Router could isolate the NetCom in the
network behind the Router, disconnecting it from other Clients


* RELEASE_2_4_1 2007/02/15:
Features:
    ARM9 Devices:
    *************
    - now the driver detects the auth mode automatically (open, shared)
    - added mark and space functionality in the serial driver

Bugfixes:
    ARM9 Devices:
    *************
    - fixed some editing problems with the encryption key
    - absolutely correct identification of the basebaud 
    - IP-Modem: the config string now correctly modifies the factory
      parameters
    - Webfrontend: added additional error strings for contact and location
    

* RELEASE_2_4_0 2006/03/31:
Features:
    ARM7 Devices:
    *************
    - advanced support for 16C950 UARTs (128 byte FIFO, adjustable trigger levels,
      unconventional baudrates)
    ARM9 Devices:
    *************
    - PPP support added
    - Wireless: added support for the Ralink RT2561 chip
    All Devices:
    ************
    - UDP Mode: UDP Timeout with -1 value switches timeouts off. It will be sent only
      if trigger pattern received.
                          
Bugfixes:
    ARM7 Devices:
    *************
    - SNTP: SNTP initialization happens after network interface initialization
    - improved crystal speed detection for UARTs
    ARM9 Devices:
    *************
    - SNTP: two or more timeservers will be accepted
    All Devices:
    ************
    - Driver mode and Tcp Raw Server: if accept fails the connection will be closed anyway


* RELEASE_2_2_0 2005/10/31:
Features:
    Wireless Devices:
    *****************
    - Added OpenVPN support. 
    - Added WPA-PSK support.
    - Configuration: It's now possible to do a wireless scanning
      for other devices and to see the wireless bitrate.
    - special support for the 16950 UART is been added 
      (advanced values for the trigger levels and speed settings).
    - added autodetection of the crystal frequency for the
      serial ports.
    All Devices:
    ************
    - Added Print Server support (LPD).
    - TCP Raw Server: It's now possible to set a password for 
      each serial port so the TCP clients must be authenticated.

Bugfixes:
    Wireless Devices:
    *****************
    - Fixed the configuration of the CountryRegion. The driver
      didn't set another channel outside the FCC region (1-11)
      correctly.
    - Fixed the counting of the DSR/CTS changes.
    All Devices:
    ************
    - Fixed the error handling for EBADF in the tcp modes.

Internals:
    All Devices:
    ************
    - Initialisation of parameter arrays for the serial ports
      are also dynamic now.
    - changed the priorities of the configuration threads.


* RELEASE_2_0_0 2005/05/13:
Features:
    - It is now possible to set the password as plain text
      via SNMP and in a parameter file.
    - It's now possible to set the port type via software
    - Telnet: the text input field has more options
      (like cursor support)
    - TCP Raw Client: added support for multiple destinations
    - Added the IP Modem functionality

Bugfixes:
    - Fixed bug in UDP Mode, which could cause panic while startup
      since 1.8.3.
    - Fixed bugs which can cause error messages, when loading a 
      parameter file which was saved with the Windows Driver.
    - Fixed bug which could cause a hanging system when setting
      the time with configured password.
    - Fixed the MTU size problem in the UDP Mode. 
    - Didn't handle the incoming broadcasts that we've sent (UDP Mode)
    - fixed the triggered mode in TCP Client Mode
    - Driver Mode: RTS and CTS won't be set anymore on connect
    - fixed the timer handling routines
    - fixed the sntp offer for MS-sntp-servers
    - fixed unknown DNS-name reply and the memory-leak if the thread exits


* RELEASE_1_8_3 2004/10/19:

Features:
    - It is now possible to set broadcast addresses in 
      UDP Mode.
    - Added more useful Log messages

Bugfixes:
    - Fixed typo in date which caused march to be mars.
    - Fixed problem if a connection get lost and 
      immediately connected again. The second connection
      was reject, although the privios has been closed
      and should be free.
    - UDP Mode could had send currupted data, if serial
      data comes slow with more then one trigger 
      characters configured.


* RELEASE_1_8_0 2004/08/04:

Features:
    - Driver Mode Protocol supports now Remote Handshake 
      Mode.
    - If serial console is chosen, it is now possible to
      cancel the DHCP request.
    - The uptime is now shown in the menu.

Bugfixes:
    - Fixed bug in timer functionality, which could cause
      unexpected lost timeout events.
    - Fixed bug which causes handshake events in Driver Mode
      got lost.
    - The driver had got always the default values of trigger
      levels instead of getting the actual ones.
    - Added help text for UART Model.
    - Fixed saving of the configured Model.
    - Driver Mode: Sends now an overrun event if the buffer
      overruns.
    - The NetCom doesn't send unnecessary option anymore to
      avoid problems with Windows DHCP Server.
    - SNMP sysUpTime will be right after changing the system
      time.
    - Null Modem Tunnel Mode: Sent break condition could have
      been to short.


* RELEASE_1_6_0 2004/04/26:

Features:
    - Added Syslog support. The NetCom could be configured
      now to send log messages to a syslog daemon. This
      messages could also watched over telnet to a special
      port.
    - Added Date support with SNTP. It is now possible to
      set the time and date. Using an SNTP server the time
      could be got automaticly.
    - Every baudrate is now manual setable depending on
      the UART Model of the NetCom. If the value couldn't
      set within 5% difference, an error will be generated
      and no connection will be admitted.
    - If an error occur while saving, the variable name and
      a specific error message will be displayed.
    - SNMP: Over value vsnciLastStatus.0 it is possible now
      to get the last status if an SNMP request failed.
    - The configuration parameter could now be save to a
      file and later loaded back from it.
    - It is now possible to set the password over SNMP in
      plaintext.
    - Added a new command in Driver Protocol to support
      Driver which let the handshake make by the NetCom.

Bugfixes:
    - Additional fixes to avoid hanging connections.
    - Make sure that every data left in the buffers are
      send over the serial interface if the connection
      are finished.
    - If in TCP Client Triggered Mode, make sure to wait
      a second before give up if we get no responce from
      peer.
    - Fix bug which could cause longer receive timeouts
      in NetCom 111 and 113.
    - Fixed "Ping-Bug": the Ip-address of the Netcom changed
      to the destination Ping-address.
    - If parmameter of TCP Mode are changed while Udp Mode
      is activ, it won't interrupt the UDP Mode and the
      other way.


* RELEASE_1_4_4 2004/03/30:

Version like 1.4.2 but add support for NetCom 111M.


* RELEASE_1_4_2 2004/03/02:

Bugfixes:
    - Fixed bug which could cause the NetCom to crash while
      serial communication or initialization.
      This could only happen with a NetCom 111.


* RELEASE_1_4_0 2004/02/16:

Features:
    - The telnet menu will be closed now after 10 min.
      without typing somthing.
    - If using the serial console menu, it will be restarted
      if the DSR signal switches from off to on.
    - It is now possible to enable and configure the TCP
      keepalive option globaly for all connections.

Bugfixes:
    - If in Driver Mode and the Control connection gets
      lost, the Data connection will be resetet also, to
      be sure not to be left in a bad state.
    - If the DHCP lease finally expires, the NetCom will
      close all connections and restart.
    - Bug fixed which could have made problems with UDP
      Mode timouts on multiport NetCom's.
    - Driver Mode Keepalive tests are working now also,
      if the Driver trys to connect very often. It aslo
      works if of any reason only the Control port is
      open.
    - Fixed bug in Webfrontend which was saving the wrong
      values of the listboxes.
    - Fixed a bug if the NetCom try to reconnect after a
      lost connection.
    - Fixed a bug which could cause that there is more data
      sent then received. Was mostly happen, if some sort
      of flowcontrol was used.
    - Fixed bug with XON/XOFF in Null Modem Tunnel Mode.
      The NetCom had not stopped sending it had received a
      XOFF character.
    - In XON/XOFF Mode it sends now faster the XOFF
      character, therewith it can't lose incomming characters.


* RELEASE_1_3_2 2004/01/08:
ATTENTION: This is a special version, which is not released for public
customers.

Bugfixes:
    - Fixed problem, that data was lost while receiving
      UDP packages.


* RELEASE_1_3_1 2004/01/07:

ATTENTION: This is a special version, which is not released for public
customers.

Features:
    - UDP Mode is implemented now. It is possible to set a timout
      value after which the received bytes are send to the
      destination. The NetCom scans the incomming data for trigger
      characters, if they match the data will be send too.
    - The NetCom sends its "Server Name" as Hostname with the
      DHCP request.
    - If the DHCP Server send a hostname, the NetCom use it as
      "Server Name".
    - Make sysContact and sysLocation setable in Webfrontend and
      Telnet menue.
    - Netstat and Statistic is now also included in the Webfrontend.

Bugfixes:
    - Typo fix in configuration menu.


* RELEASE_1_2_0 2003/09/19:

Features:
    - Telnet: netstat implementation for tcp connections.
    - Web: help support for configuration options.
    - Multi Connection support: The max. number of connections
      allowed is now configureable over SNMP, telnet and Webfrontend.
    - Security: If a Raw Mode connection is established, it is no
      longer possible to connect to the control port. So the port
      will not be unmeant switched to Driver Mode.
    - Security: If in Driver Mode the NetCom now only accepts
      connection from the same ip-address on the two ports.
    - Security: If in Driver Mode the NetCom now close a Control
      port connection if nobody connects after 1 min. at the Data
      port.
    - Firmware is now compressed.

Bugfixes:
    - Change the timing accessing the external UART.
    - Fixed broken configurations after failed DHCP request.
    - Fixed crash, if a client disconnects before the NetCom has
      accepted the connection.
    - Changed DHCP retries from 5 to 4, to reduce the timeout from
      120 s to 60 s.
    - If in TCP Client Mode Triggered, the NetCom haven't sent the
      first byte received from the serial port. This bug was only
      in version 1.1.3.
    - If the ShortHoldTime expires, it will be ensured, that there
      is no data left in any buffers before the connction will be
      closed.
    - Don't allow wrong IP-address like 0.0.0.0 or one with 255 in
      or 127.x.x.x.
    - Keep Alive tests wasn't working in version 1.1.3.
    - In version 1.1.3 the NetCom accepted multiple connection
      although if a Driver had connected jet.
    - Fix data lost at the beginning of a connection in TCP Client
      Mode in version 1.1.3.
    - Fix bug if multiple clients are connected and using handshake.
    - Fix bug in the tcpip stack if a RST doesn't match the last
      ACK sequence nummber, but fit in the window.
    - It is now possible to change serial settings in the serial
      console without changing the actual used settings.
    - Firmware update with a multible images file works now over
      serial console.
    - Fix bug if the TCP port is changed while connected, it wasn't
      updated after disconnect.
    - Fix bug if Null Modem Tunnel Mode don't connect right the fist
      time after reboot.
    - In Null Modem Tunnel Mode the synconisation of modem control
      lines works now better.
    - In Telnet menu "Save parameter" is now under "Save&Exit".


* RELEASE_1_1_3 2003/07/16:

ATTENTION: This is a special version, which is not released for public
customers.

Features:
    - Multi Connection support: The NetCom allows now in TCP Raw Server
      mode multiple connections simultaneous.
      Every byte received on any connection will be sent out on the
      serial line. Every byte received on the serial line will be sent
      on each connections.

Bugfixes:
    - SNMP: The entry vsnciPrdType of the vscom MIB responses now with
      the right length of the string.


* RELEASE_1_0_3 2003/07/16:

Bugfixes:
    - Without a real physical connected Ethernet, the NetCom doesn't make
      a DHCP request. Since the with the factory settings DHCP is enabled,
      it takes a long time for booting, if there is no DHCP server in the
      net. Just disconnecting the NetCom from Ethernet let him start without
      waiting for a DHCP response.
    - If the NetCom is configured to use DHCP, but the request fails, it
      doesn't starts a DHCP request again after some minutes, because the
      NetCom would loose all connection for this time.
    - Fixed broken firmware update over SNMP.
    - Fixed loosing FLASH space if a firmware is smaller then the old one.
    - In TCP Raw Client mode with Permanent connection chosen the NetCom
      will try to reconnect the destination if the connection was lost.
    - The TCP Raw Client mode doesn't disconnect anymore after changing
      from Triggered to Permanent connection.
    - Break Signal sending and receiving works now with Driver Mode and
      Null Modem Tunnel.


* RELEASE_1_0_2 2003/06/10:

Features:
    - Transfer modes:
        Driver Mode
        Null Modem Tunnel
        TCP Raw Server
        TCP Raw Client
        TCP Advanced Settings
    - Driver automaticly finds NetCom devices in the network
    - Automatic mode switching between Driver and Raw mode.
      With TCP Advanced Settings it is possible to configure
      the NetCom for using it in multiple modes, so it
      decides automaticly which mode should be used.
    - Configuration over:
        Driver panels
        NetCom Manager
        Serial console
        Telnet
        Web browser
        SNMP v3
    - SNMP: special VScom MIB included
    - Domane Name System (DNS) support
    - Serial interface configurable with external switch
    - Firmware update possible over every capabilities of
      configuration
    - Special precautions for Firewall environments
